/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.util.Enumeration;
import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Observable;
import java.util.Observer;

import javax.servlet.* ;
/**
 *
 * @author khetho
 */


class Conference {
    public int roomNumber;
   // public String text;
    
    public ArrayList<PrivateClient> clientList;
    private MessageSource source = new MessageSource ();
     private MessageSource userSource = new MessageSource ();
      private MessageSource removeSource = new MessageSource ();
    
    // getNextMessage() returns the next new message.
    // It blocks until there is one.
    public String getNextMessage() {
        // Create a message sink to wait for a new message from the
        // message source.
        return new MessageSink().getNextMessage(source);
    }
   public String getNextUser() {
        // Create a message sink to wait for a new message from the
        // message source.;
       String user  = new MessageSink().getNextMessage(userSource);
System.out.println("usernameIn NU: "+user);
        return user;
        
    }
   
    public String getRemoveUser() {
        // Create a message sink to wait for a new message from the
        // message source.;
       String user  = new MessageSink().getNextMessage(removeSource);
    System.out.println("NextRemoverUser: usernameIn NU: "+user);
        return user;
        
    }
  
    // broadcastMessage() informs all currently listening clients that there
    // is a new message.  Causes all calls to getNextMessage() to unblock
    public void broadcastMessage(String message) {
        // Send the message to all the HTTP-connected clients by giving the
        // message to the message source
        if (source == null){
            source = new MessageSource ();
        }
        source.sendMessage(message);
    }
    public void broadcastUser(String user) {
        // Send the message to all the HTTP-connected clients by giving the
        // message to the message source
        
        if (userSource == null){
            userSource = new MessageSource ();
        }
        userSource.sendMessage(user);
        System.out.println("usernameIn BCU: "+user);
    }
    
     public void broadcastRemoveUser(String user) {
        // Send the message to all the HTTP-connected clients by giving the
        // message to the message source
        
        if (removeSource == null){
            removeSource = new MessageSource ();
        }
        removeSource.sendMessage(user);
        System.out.println("Remove: usernameIn BCU: "+user);
    }
     
    
}
class PrivateClient{
 
    public int room;
     public String pUsername;
  //public ArrayList<String> clientList2;
    private MessageSource source2 = new MessageSource ();  
    public String getNextMessage2() {
        // Create a message sink to wait for a new message from the
        // message source.
        return new MessageSink2().getNextMessage2(source2);
    }
  
    // broadcastMessage() informs all currently listening clients that there
    // is a new message.  Causes all calls to getNextMessage() to unblock
    public void broadcastMessage2(String message,PrivateClient receiver) {
        // Send the message to all the HTTP-connected clients by giving the
        // message to the message source
        
       
        
        if (receiver.source2 == null){
            receiver.source2 = new MessageSource ();
        }
        receiver.source2.sendMessage(message);
    
     if (source2 == null){
            source2 = new MessageSource ();
        }
        source2.sendMessage(message);
       }
}
@WebServlet(name = "ChatServlet", urlPatterns = {"/ChatServlet"})
public class ChatServlet extends HttpServlet {

          //public String text;
            private ArrayList<Conference> conferenceList;
    
   
    /************************/
    /*public String getNextMessage() { 
        // Create a message sink to wait for a new message from the 
        // message source. 
        return new MessageSink().getNextMessage(source); 
    }*/
    
    // broadcastMessage() informs all currently listening clients that there
    // is a new message. Causes all calls to getNextMessage() to unblock. 
    /*public void broadcastMessage(String message) { 
        // Send the message to all the HTTP-connected clients by giving the 
        // message to the message source 
        source.sendMessage(message);
    }*/
    
     /************************/

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            System.out.println("Servlet says: This is working after all");
           
            String connectionType = request.getParameter("connectionType");
            String username = request.getParameter("name");
            int roomNumber = Integer.parseInt(request.getParameter("id"));
            System.out.println("In Servlet Room no: "+roomNumber);
                
            System.out.println("Connection type: "+connectionType);
           if (connectionType.equalsIgnoreCase("Receive")){
                System.out.println("In Recieve");
                for(Conference conf : conferenceList){
                      if(conf.roomNumber == roomNumber){
                          //out.println(conf.text);
                          response.setContentType("text/plain");
                          // Return the next message (blocking)
                          out.println(conf.getNextMessage());
                           
                           break;
                      }
                 }
            }
            
           else if (connectionType.equalsIgnoreCase("ReceiveUser")){
                System.out.println("In ReceiveUser");
                for(Conference conf : conferenceList){
                      if(conf.roomNumber == roomNumber){
                          //out.println(conf.text);
                          String user = conf.getNextUser();
                          response.setContentType("text/plain");
                          if (user.equals(username)){
                              user = "";
                          }
                          // Return the next message (blocking)
                          out.print(user);
                           
                           break;
                      }
                 }
            }
            else if (connectionType.equalsIgnoreCase("RemoveUser")){
                System.out.println("In RemoveUser");
                System.out.println("RoomNumber Testing: "+roomNumber);
                for(Conference conf : conferenceList){
                      if(conf.roomNumber == roomNumber){
                          //out.println(conf.text);
                          String user = conf.getRemoveUser();
                          response.setContentType("text/plain");
                         /* if (user.equals(username)){
                              user = "";
                          }*/
                          // Return the next message (blocking)
                          out.print(user);
                           
                           break;
                      }
                 }
            }
           else if (connectionType.equalsIgnoreCase("ReceivePrivate")){
               System.out.println("In ReceivePrivate");
                String pUsername = request.getParameter("pname");
                System.out.println("PrivateUser: "+pUsername);
                 for(Conference conf : conferenceList){
                      if(conf.roomNumber == roomNumber){
                for(PrivateClient client: conf.clientList){
                     
                      if(client.pUsername.equals(pUsername))
                         {
                          
                          response.setContentType("text/plain");
                          // Return the next message (blocking)
                          out.println(client.getNextMessage2());
                           
                           break;
                      }
                 }
                     }
                 }
            }
            
            
           else if (connectionType.equalsIgnoreCase("Chat")){
               System.out.println("In Chat");
                String message = request.getParameter("message");
                String colours = request.getParameter("colour");
                System.out.println("colour is: "+colours);
                System.out.println("publicMessage: "+message);
                for(Conference conf : conferenceList){
                      if(conf.roomNumber == roomNumber){
                          //out.println(conf.text);
                          if (message != null) 
                              conf.broadcastMessage("<"+ username+ "> "+message);
                           response.setStatus(response.SC_NO_CONTENT);
                           
                           break;
                      }
                 }
            }
             
                    
           else if (connectionType.equalsIgnoreCase("PrivateChat")){
               System.out.println("In PrivateChat");
                String pmessage = request.getParameter("pmessage");
               
                System.out.println("In servlet privateMessage: "+pmessage+".");
               String pUsername = request.getParameter("pname");
               System.out.println("pUsername in Servlet: "+pUsername);
                String receiver = request.getParameter("preceiver").replaceAll("[\n\r]", "");
                System.out.println("preceiver in Servlet: "+receiver+".");
                for(Conference conf : conferenceList){
                      if(conf.roomNumber == roomNumber){
                          
                          PrivateClient receiverClient = null;
                          for(PrivateClient client : conf.clientList){
                               if(client.pUsername.equals(receiver)){
                                   receiverClient = client;
                                   break;
                               }
                          }
                          
                          if(receiverClient==null)
                          {
                               break;
                          }
                              
                for(PrivateClient client : conf.clientList){
                    //System.out.println("Users from con.username "+con.username);
                       //con.pUsername = request.getParameter("pname");
                       //System.out.println("In servlet privateUser: "+con.pUsername);
                      if(client.pUsername.equals(pUsername)){
                          System.out.println("broadcastMessage2: "+receiverClient.pUsername+".");
                          if (pmessage != null) 
                              client.broadcastMessage2("<"+ client.pUsername+ "> "+"->"
                                      + "<" +receiver+ "> "+pmessage,receiverClient);
                          
                           response.setStatus(response.SC_NO_CONTENT);
                           
                           break;
                      }
                           
                 }
                   }
                }
                
           }
          
           else if (connectionType.equalsIgnoreCase("Exit")){
                 System.out.println("In Exit");
                 for(Conference conf : conferenceList){
                      if(conf.roomNumber == roomNumber){
                           System.out.println("In Servlet Room no: "+roomNumber);
                          System.out.println("Username remove: "+username);
                           for (PrivateClient client: conf.clientList){
                                 if (client.pUsername.equals (username)){
                                     conf.clientList.remove(client);
                                     System.out.println("ClientRemoved: "+client.pUsername);
                                     conf.broadcastRemoveUser(username);
                               }
                            }
                           if (conf.clientList.size()==0){
                               conferenceList.remove(conf);
                               System.out.println("Conference deleted");
                           }
                           break;
                      }
                 }
           }
             else if (connectionType.equalsIgnoreCase("Enter")){
                 System.out.println("In Enter");
                if (conferenceList == null){
                    //out.println("Conference List is nil");
                    conferenceList = new ArrayList<Conference> ();
                }
                else{
                    //out.println("Number of conferences: "+conferenceList.size());
                }

                 boolean conferenceExists = false;
                 for(Conference conf : conferenceList){
                      if(conf.roomNumber == roomNumber){
                            conferenceExists = true;
                            boolean userExists = false;
                            
                            for (PrivateClient client: conf.clientList){
                                //out.println("Connected users:");
                                out.println(client.pUsername);
                                
                                if (client.pUsername.equals (username)){
                                    userExists = true;
                                    break;
                                }
                            }
                            if (!userExists){
                                //out.println("Add a new user name: " + username + " to conference: "+conf.roomNumber);
                                PrivateClient newClient = new PrivateClient();
                                newClient.pUsername = username;
                                newClient.room = roomNumber;
                                conf.clientList.add(newClient);
                                conf.broadcastUser(username);
                            }
                            break;
                       }
                 }
                 if (!conferenceExists){
                     //Add conference number
                     //out.println("Add a new conference number: " + roomNumber);
                     Conference newConf = new Conference ();
                     newConf.clientList = new ArrayList<PrivateClient> ();
                     newConf.roomNumber = roomNumber;

                     
                     //out.println("Add a new user name: " + username + " to conference: "+newConf.roomNumber);
                     PrivateClient newClient = new PrivateClient();
                     newClient.pUsername = username;
                     newClient.room = roomNumber;
                     newConf.clientList.add(newClient);
                     conferenceList.add(newConf);
                     newConf.broadcastUser(username);
                     //out.println(newClient.pUsername);
                     System.out.println("Number of conferences: "+newConf.clientList.size());
                 }
            }
             out.close();
             System.out.println("In the doGet method");

        } finally {            
            out.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);  
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
    
    
}


// MessageSource acts as the source for new messages.
// Clients interested in receiving new messages can
// observe this object.
class MessageSource extends Observable {
  public void sendMessage(String message) {
    setChanged();
    notifyObservers(message);
  }
}

// MessageSink acts as the receiver of new messages.
// It listens to the source.
class MessageSink implements Observer {

  String message = null;  // set by update() and read by getNextMessage()

  // Called by the message source when it gets a new message
  synchronized public void update(Observable o, Object arg) {
    // Get the new message
    message = (String)arg;
   
    // Wake up our waiting thread
    notify();
  }

  // Gets the next message sent out from the message source
  synchronized public String getNextMessage(MessageSource source) {
    // Tell source we want to be told about new messages
    source.addObserver(this);

    // Wait until our update() method receives a message
    while (message == null) {
      try { wait(); } catch (Exception ignored) { }
    }

    // Tell source to stop telling us about new messages
    source.deleteObserver(this);

    // Now return the message we received
    // But first set the message instance variable to null
    // so update() and getNextMessage() can be called again.
    String messageCopy = message;
    message = null;
    return messageCopy;
  }
}

class MessageSink2 implements Observer {

  String message = null;  // set by update() and read by getNextMessage()

  // Called by the message source when it gets a new message
  synchronized public void update(Observable o, Object arg) {
    // Get the new message
    message = (String)arg;

    // Wake up our waiting thread
    notify();
  }

  // Gets the next message sent out from the message source
  synchronized public String getNextMessage2(MessageSource source2) {
    // Tell source we want to be told about new messages
    source2.addObserver(this);

    // Wait until our update() method receives a message
    while (message == null) {
      try { wait(); } catch (Exception ignored) { }
    }

    // Tell source to stop telling us about new messages
    source2.deleteObserver(this);

    // Now return the message we received
    // But first set the message instance variable to null
    // so update() and getNextMessage() can be called again.
    String messageCopy = message;
    message = null;
    return messageCopy;
  }
}
  

